Index: branches/0.2-poznan-univ/source/Lib/TLibCommon/TComPic.cpp
===================================================================
--- branches/0.2-poznan-univ/source/Lib/TLibCommon/TComPic.cpp	(revision 11)
+++ branches/0.2-poznan-univ/source/Lib/TLibCommon/TComPic.cpp	(revision 12)
@@ -50,9 +50,12 @@
   m_apcPicYuv[0]      = NULL;
   m_apcPicYuv[1]      = NULL;
-#if POZNAN_AVAIL_MAP
+#if POZNAN_CU_SYNTH || POZNAN_CU_SKIP || POZNAN_TEXTURE_TU_DELTA_QP_ACCORDING_TO_DEPTH
   m_apcPicYuvAvail     = NULL;
 #endif
-#if POZNAN_SYNTH_VIEW
+#if POZNAN_CU_SYNTH
   m_apcPicYuvSynth     = NULL;
+#if POZNAN_TEXTURE_TU_DELTA_QP_ACCORDING_TO_DEPTH
+  m_apcPicYuvSynthDepth= NULL; 
+#endif
 #endif
 #if DEPTH_MAP_GENERATION
@@ -122,5 +125,5 @@
     m_apcPicYuv[1]  = NULL;
   }
-#if POZNAN_AVAIL_MAP
+#if POZNAN_CU_SYNTH || POZNAN_CU_SKIP || POZNAN_TEXTURE_TU_DELTA_QP_ACCORDING_TO_DEPTH
   if (m_apcPicYuvAvail)
   {
@@ -131,5 +134,5 @@
 #endif
 
-#if POZNAN_SYNTH_VIEW
+#if POZNAN_CU_SYNTH
   if (m_apcPicYuvSynth)
   {
@@ -138,4 +141,12 @@
     m_apcPicYuvSynth  = NULL;
   }
+#if POZNAN_TEXTURE_TU_DELTA_QP_ACCORDING_TO_DEPTH
+  if (m_apcPicYuvSynthDepth)
+  {
+    m_apcPicYuvSynthDepth->destroy();
+    delete m_apcPicYuvSynthDepth;
+    m_apcPicYuvSynthDepth  = NULL;
+  }
+#endif
 #endif
   
@@ -216,5 +227,5 @@
 }
 
-#if POZNAN_AVAIL_MAP
+#if POZNAN_CU_SYNTH || POZNAN_CU_SKIP || POZNAN_TEXTURE_TU_DELTA_QP_ACCORDING_TO_DEPTH
 Void
 TComPic::addAvailabilityBuffer()
@@ -232,5 +243,5 @@
 #endif
 
-#if POZNAN_SYNTH_VIEW
+#if POZNAN_CU_SYNTH
 Void
 TComPic::addSynthesisBuffer()
@@ -246,4 +257,19 @@
   m_apcPicYuvSynth      ->create( iWidth, iHeight, uiMaxCuWidth, uiMaxCuHeight, uiMaxCuDepth );
 }
+#if POZNAN_TEXTURE_TU_DELTA_QP_ACCORDING_TO_DEPTH
+Void
+TComPic::addSynthesisDepthBuffer()
+{
+  AOT( m_apcPicYuvSynthDepth );
+  AOF( m_apcPicYuv[1] );
+  Int   iWidth        = m_apcPicYuv[1]->getWidth      ();
+  Int   iHeight       = m_apcPicYuv[1]->getHeight     ();
+  UInt  uiMaxCuWidth  = m_apcPicYuv[1]->getMaxCuWidth ();
+  UInt  uiMaxCuHeight = m_apcPicYuv[1]->getMaxCuHeight();
+  UInt  uiMaxCuDepth  = m_apcPicYuv[1]->getMaxCuDepth ();
+  m_apcPicYuvSynthDepth      = new TComPicYuv;
+  m_apcPicYuvSynthDepth      ->create( iWidth, iHeight, uiMaxCuWidth, uiMaxCuHeight, uiMaxCuDepth );
+}
+#endif
 #endif
 
@@ -339,5 +365,5 @@
 }
 
-#if POZNAN_AVAIL_MAP
+#if POZNAN_CU_SYNTH || POZNAN_CU_SKIP || POZNAN_TEXTURE_TU_DELTA_QP_ACCORDING_TO_DEPTH
 Void
 TComPic::removeAvailabilityBuffer()
@@ -352,5 +378,5 @@
 #endif
 
-#if POZNAN_SYNTH_VIEW
+#if POZNAN_CU_SYNTH
 Void
 TComPic::removeSynthesisBuffer()
@@ -363,4 +389,16 @@
   }
 }
+#if POZNAN_TEXTURE_TU_DELTA_QP_ACCORDING_TO_DEPTH
+Void
+TComPic::removeSynthesisDepthBuffer()
+{
+  if( m_apcPicYuvSynthDepth )
+  {
+    m_apcPicYuvSynthDepth->destroy();
+    delete m_apcPicYuvSynthDepth;
+    m_apcPicYuvSynthDepth  = NULL;
+  }
+}
+#endif
 #endif
 
@@ -430,5 +468,5 @@
 #endif
 
-#if POZNAN_AVAIL_MAP
+#if POZNAN_CU_SYNTH || POZNAN_CU_SKIP
 Void TComPic::checkSynthesisAvailability( TComDataCU*& rpcCU, UInt iCuAddr, UInt uiAbsZorderIdx, UInt uiPartDepth, Bool *&rpbCUSynthesied )
 { 
Index: branches/0.2-poznan-univ/source/Lib/TLibCommon/TComPic.h
===================================================================
--- branches/0.2-poznan-univ/source/Lib/TLibCommon/TComPic.h	(revision 11)
+++ branches/0.2-poznan-univ/source/Lib/TLibCommon/TComPic.h	(revision 12)
@@ -62,10 +62,13 @@
   TComPicYuv*           m_apcPicYuv[2];           //  Texture,  0:org / 1:rec
 
-#if POZNAN_AVAIL_MAP
+#if POZNAN_CU_SYNTH || POZNAN_CU_SKIP || POZNAN_TEXTURE_TU_DELTA_QP_ACCORDING_TO_DEPTH
   TComPicYuv*           m_apcPicYuvAvail;         //  Availability Map - Does the given pixel can be synthesised in receiver
 #endif
 
-#if POZNAN_SYNTH_VIEW
+#if POZNAN_CU_SYNTH
   TComPicYuv*           m_apcPicYuvSynth;         //  Sythesied image
+#if POZNAN_TEXTURE_TU_DELTA_QP_ACCORDING_TO_DEPTH
+  TComPicYuv*           m_apcPicYuvSynthDepth;         //  Sythesied depth image
+#endif
 #endif
 
@@ -107,4 +110,9 @@
 #if HHI_INTERVIEW_SKIP
   TComPicYuv*           m_pcUsedPelsMap;
+#endif
+#if POZNAN_TEXTURE_TU_DELTA_QP_PARAM_IN_CFG_FOR_ENC 
+  Double                m_dTextureCuDeltaQpOffset;
+  Double                m_dTextureCuDeltaQpMul;
+  Int                   m_iTextureCuDeltaQpTopBottomRow; 
 #endif
 
@@ -136,10 +144,13 @@
   TComPicYuv*   getPicYuvRec()        { return  m_apcPicYuv[1]; }
 
-#if POZNAN_AVAIL_MAP
+#if POZNAN_CU_SYNTH || POZNAN_CU_SKIP || POZNAN_TEXTURE_TU_DELTA_QP_ACCORDING_TO_DEPTH
   TComPicYuv*   getPicYuvAvail()      { return  m_apcPicYuvAvail; } //Owieczka - returns available map from other pic image
 #endif
 
-#if POZNAN_SYNTH_VIEW
+#if POZNAN_CU_SYNTH
   TComPicYuv*   getPicYuvSynth()      { return  m_apcPicYuvSynth; } //Owieczka - returns synth form other pic in image
+#if POZNAN_TEXTURE_TU_DELTA_QP_ACCORDING_TO_DEPTH
+  TComPicYuv*   getPicYuvSynthDepth() { return  m_apcPicYuvSynthDepth; };    //  Sythesied depth image
+#endif
 #endif
 
@@ -213,9 +224,12 @@
 
   Void          addOriginalBuffer       ();
-#if POZNAN_AVAIL_MAP
+#if POZNAN_CU_SYNTH || POZNAN_CU_SKIP || POZNAN_TEXTURE_TU_DELTA_QP_ACCORDING_TO_DEPTH
   Void          addAvailabilityBuffer   ();
 #endif
-#if POZNAN_SYNTH_VIEW
+#if POZNAN_CU_SYNTH
   Void          addSynthesisBuffer      ();
+#if POZNAN_TEXTURE_TU_DELTA_QP_ACCORDING_TO_DEPTH
+  Void          addSynthesisDepthBuffer ();
+#endif
 #endif
 #if PARALLEL_MERGED_DEBLK
@@ -237,8 +251,11 @@
 
   Void          removeOriginalBuffer    ();
-#if POZNAN_SYNTH_VIEW
+#if POZNAN_CU_SYNTH
   Void          removeSynthesisBuffer   ();
-#endif
-#if POZNAN_AVAIL_MAP
+#if POZNAN_TEXTURE_TU_DELTA_QP_ACCORDING_TO_DEPTH
+  Void          removeSynthesisDepthBuffer ();
+#endif
+#endif
+#if POZNAN_CU_SYNTH || POZNAN_CU_SKIP || POZNAN_TEXTURE_TU_DELTA_QP_ACCORDING_TO_DEPTH
   Void          removeAvailabilityBuffer();
 #endif
@@ -259,5 +276,5 @@
 #endif
 
-#if POZNAN_AVAIL_MAP
+#if POZNAN_CU_SYNTH || POZNAN_CU_SKIP
   Void          checkSynthesisAvailability(  TComDataCU*& rpcBestCU, UInt iCuAddr, UInt uiAbsZorderIdx, UInt uiPartDepth, Bool *&rpbCUSynthesied);
 #endif
@@ -280,4 +297,12 @@
   const SEImessages* getSEIs() const { return m_SEIs; }
 
+#if POZNAN_TEXTURE_TU_DELTA_QP_PARAM_IN_CFG_FOR_ENC 
+  Double getTextureCuDeltaQpOffset( )      { return m_dTextureCuDeltaQpOffset;}
+  Double getTextureCuDeltaQpMul( )         { return m_dTextureCuDeltaQpMul;}
+  Int    getTextureCuDeltaQpTopBottomRow( ){ return m_iTextureCuDeltaQpTopBottomRow;}
+  Void   setTextureCuDeltaQpOffset      ( Double dTextureCuDeltaQpOffset    ){ m_dTextureCuDeltaQpOffset       = dTextureCuDeltaQpOffset; }
+  Void   setTextureCuDeltaQpMul         ( Double dTextureCuDeltaQpMul       ){ m_dTextureCuDeltaQpMul          = dTextureCuDeltaQpMul; }
+  Void   setTextureCuDeltaQpTopBottomRow( Int iTextureCuDeltaQpTopBottomRow ){ m_iTextureCuDeltaQpTopBottomRow = iTextureCuDeltaQpTopBottomRow; }  
+#endif 
 };// END CLASS DEFINITION TComPic
 
Index: branches/0.2-poznan-univ/source/Lib/TLibCommon/TComPicSym.cpp
===================================================================
--- branches/0.2-poznan-univ/source/Lib/TLibCommon/TComPicSym.cpp	(revision 11)
+++ branches/0.2-poznan-univ/source/Lib/TLibCommon/TComPicSym.cpp	(revision 12)
@@ -18,4 +18,7 @@
   m_uiNumPartitions   = 1<<(m_uhTotalDepth<<1);
   
+  m_iPicWidth         = iPicWidth;
+  m_iPicHeight        = iPicHeight;
+
   m_uiMaxCUWidth      = uiMaxWidth;
   m_uiMaxCUHeight     = uiMaxHeight;
Index: branches/0.2-poznan-univ/source/Lib/TLibCommon/TComPicSym.h
===================================================================
--- branches/0.2-poznan-univ/source/Lib/TLibCommon/TComPicSym.h	(revision 11)
+++ branches/0.2-poznan-univ/source/Lib/TLibCommon/TComPicSym.h	(revision 12)
@@ -43,4 +43,8 @@
 
 // Include files
+#if POZNAN_MP
+#include "../TLibCommon/TComMP.h"
+#endif
+
 #include "CommonDef.h"
 #include "TComSlice.h"
@@ -58,4 +62,6 @@
   UInt          m_uiHeightInCU;
   
+  Int           m_iPicWidth;
+  Int           m_iPicHeight;
   UInt          m_uiMaxCUWidth;
   UInt          m_uiMaxCUHeight;
@@ -93,4 +99,9 @@
   UInt        getNumPartInWidth()       { return m_uiNumPartInWidth;            }
   UInt        getNumPartInHeight()      { return m_uiNumPartInHeight;           }
+  Int   getPicWidth    () {return m_iPicWidth;}
+  Int   getPicHeight   () {return m_iPicHeight;}
+  UInt  getMaxCUWidth  () {return m_uiMaxCUWidth;}
+  UInt  getMaxCUHeight () {return m_uiMaxCUHeight;}
+  UChar getTotalDepth  () {return m_uhTotalDepth;}
 };// END CLASS DEFINITION TComPicSym
 
Index: branches/0.2-poznan-univ/source/Lib/TLibCommon/TComPicYuv.cpp
===================================================================
--- branches/0.2-poznan-univ/source/Lib/TLibCommon/TComPicYuv.cpp	(revision 11)
+++ branches/0.2-poznan-univ/source/Lib/TLibCommon/TComPicYuv.cpp	(revision 12)
@@ -8,4 +8,5 @@
 #include <assert.h>
 #include <memory.h>
+#include <math.h>
 
 #ifdef __APPLE__
@@ -16,4 +17,5 @@
 
 #include "TComPicYuv.h"
+
 
 TComPicYuv::TComPicYuv()
@@ -455,2 +457,26 @@
   }
 }
+
+#if POZNAN_NONLINEAR_DEPTH
+Void TComPicYuv::power(TComPicYuv *pcPicDst, Float p)
+{
+  Int		x,y;
+  TComPowerConverter powconv(p, g_uiBitIncrement, g_uiBitIncrement);
+
+  // Luma
+  Pel* pPelSrc = getLumaAddr();
+  Pel* pPelDst = pcPicDst->getLumaAddr();
+  for(y=0; y<m_iPicHeight; y++)
+	{
+    for(x=0; x<m_iPicWidth; x++)
+    {
+      pPelDst[x] = (Pel)( powconv(pPelSrc[x]) + 0.5);
+    }
+    pPelDst += pcPicDst->getStride();
+    pPelSrc += getStride();
+  }
+  // Chroma
+  copyToPicCb(pcPicDst);
+  copyToPicCr(pcPicDst);
+}
+#endif
Index: branches/0.2-poznan-univ/source/Lib/TLibCommon/TComPicYuv.h
===================================================================
--- branches/0.2-poznan-univ/source/Lib/TLibCommon/TComPicYuv.h	(revision 11)
+++ branches/0.2-poznan-univ/source/Lib/TLibCommon/TComPicYuv.h	(revision 12)
@@ -44,4 +44,42 @@
 #include "CommonDef.h"
 
+#if POZNAN_NONLINEAR_DEPTH
+
+#include <math.h>
+
+class TComPowerConverter // OLGIERD - Z-NL-Power conversion
+{
+private:
+  Double m_fMul;
+  Float m_fPower;
+
+public:
+
+  TComPowerConverter(Float fPower, Int iInputBitIncrement, Int iOutputBitIncrement)
+  :m_fPower(fPower)
+  {
+    Double fPostMul = (1<<(8+iOutputBitIncrement))-1; // OLGIERD ToDo - should be or not?
+    Double fPreMul  = 1.0/((1<<(8+iInputBitIncrement))-1);
+    m_fMul = fPostMul*pow(fPreMul,(Double)fPower);
+  };
+
+  inline Double operator() (Double Value)
+  {    
+    if (Value<0) return -pow( -Value,(Double)m_fPower)*m_fMul;
+    return pow(Value,(Double)m_fPower)*m_fMul;
+  };
+};
+#else
+class TComPowerConverter // OLGIERD - Z-NL-Power conversion
+{
+public:
+
+  TComPowerConverter(Float fPower, Int iInputBitIncrement, Int iOutputBitIncrement)
+  {
+  };
+
+  inline Double operator() (Double Value) { return Value; };
+};
+#endif
 // ====================================================================================================================
 // Class definition
@@ -175,4 +213,7 @@
   Void  setChromaTo  ( Pel pVal );  
 
+#if POZNAN_NONLINEAR_DEPTH
+  Void power(TComPicYuv *pcPicDst, Float p);
+#endif
 };// END CLASS DEFINITION TComPicYuv
 
